<template>
  <div
    id="menuContainer"
    class="min-w-[112px] w-[200px] max-h-[496px] rounded-[4px] py-2 h-full flex flex-col overflow-y-auto bg-surfaceLight cardShadow"
  >
    <v-list
      color="primary"
      density="compact"
      class="!py-0 w-full bg-surfaceLight"
    >
      <v-list-item
        v-for="(group, groupIndex) in newGroups"
        :key="`${group.name}`"
        :id="`${group.name}`"
        :active="false"
        class="px-0 py-0"
      >
        <div class="w-full flex flex-col">
          <svn-pro-text body-large medium color="onSurface" class="flex items-center px-4 h-10">
            {{ group.title }}
          </svn-pro-text>

          <v-list-item
            v-for="(command, commandIndex) in group.commands"
            :key="command.name"
            :id="`${command.name}`"
            :active="false"
            :value="`${command.name}`"
            @click="executeCommand(command)"
          >
            <div class="flex gap-3 items-center h-10">
              <div>
                <Icon
                  :icon="command.iconName"
                  height="24"
                  width="24"
                  class="text-onSurfaceVariant"
                />
              </div>
  
              <svn-pro-text body-large regular color="onSurface" class="whitespace-nowrap">
                {{ command.label }}
              </svn-pro-text>
            </div>
          </v-list-item>
        </div>
      </v-list-item>
    </v-list>
  </div>
</template>

<script setup>
import { ref, onMounted, onUnmounted } from 'vue';
import { Icon } from '@iconify/vue';
import GROUPS from '../utils/groups';
import SvnProText from '../../styles/SvnProText.vue';

const props = defineProps(['items', 'command', 'editor'])

const allowedCommands = ref([]);
const newGroups = ref([]);

onMounted(() => {
  selectedGroupIndex.value = 0
  selectedCommandIndex.value = 0
  
  const extensions = localStorage.getItem('SvnTiptapExtensionSlashCommand')
  allowedCommands.value = extensions
  newGroups.value = GROUPS.map(group => ({
    ...group,
    commands: group.commands.filter(command => allowedCommands?.value?.includes(command.name))
  })).filter(group => group.commands.length)
  
  window.addEventListener('keydown', onKeyDown)
})

onUnmounted(() => {
  window.removeEventListener('keydown', onKeyDown)
})

const selectedGroupIndex = ref(0)
const selectedCommandIndex = ref(0)

const onKeyDown = (event) => {
  // Arrow Down press
  if (event.key === "ArrowDown") {
    event.preventDefault()

    if (!newGroups.value.length) {
      return false
    }
    
    const commands = newGroups.value[selectedGroupIndex.value].commands

    let newCommandIndex = selectedCommandIndex.value + 1
    let newGroupIndex = selectedGroupIndex.value

    if (commands.length - 1 < newCommandIndex) {
      newCommandIndex = 0
      newGroupIndex = selectedGroupIndex.value + 1
    }

    if (newGroups.value.length - 1 < newGroupIndex) {
      newGroupIndex = 0
    }

    if (newGroupIndex === newGroups.value.length - 1 && newCommandIndex === newGroups.value[newGroupIndex].commands.length - 1) {
      let element = document.getElementById(`${newGroups.value[newGroupIndex].commands[newCommandIndex].name}`)
      if (element) {
        element.scrollIntoView({ behavior: 'smooth' })
      }
    }

    if (newGroupIndex === 0 && newCommandIndex === 0) {
      let element = document.getElementById(`menuContainer`)
      if (element) {
        element.scrollTo({top: 0, left: 0, behavior: "smooth"})
      }
    }

    selectedCommandIndex.value = newCommandIndex
    selectedGroupIndex.value = newGroupIndex

    return true
  }

  // Arrow Up press
  if (event.key === "ArrowUp") {
    event.preventDefault()
    if (!newGroups.value.length) {
      return false
    }

    let newCommandIndex = selectedCommandIndex.value - 1
    let newGroupIndex = selectedGroupIndex.value

    if (newCommandIndex < 0) {
      newGroupIndex = selectedGroupIndex.value - 1
      newCommandIndex = newGroups.value[newGroupIndex]?.commands.length - 1 || 0
    }

    if (newGroupIndex < 0) {
      newGroupIndex = newGroups.value.length - 1
      newCommandIndex = newGroups.value[newGroupIndex]?.commands.length - 1
    }

    if (newGroupIndex === newGroups.value.length - 1 && newCommandIndex === newGroups.value[newGroupIndex].commands.length - 1) {
      let element = document.getElementById(`${newGroups.value[newGroupIndex].commands[newCommandIndex].name}`)
      if (element) {
        element.scrollIntoView({ behavior: 'smooth' })
      }
    }

    if (newGroupIndex === 0 && newCommandIndex === 0) {
      let element = document.getElementById(`menuContainer`)
      if (element) {
        element.scrollTo({top: 0, left: 0, behavior: "smooth"})
      }
    }

    selectedCommandIndex.value = newCommandIndex
    selectedGroupIndex.value = newGroupIndex

    return true
  }

  // Enter Press (Execute action)
  if (event.key === "Enter") {
    if (!newGroups.value.length || selectedGroupIndex.value === -1 || selectedCommandIndex.value === -1) {
      return false
    }

    selectItem(selectedGroupIndex.value, selectedCommandIndex.value)

    return true
  }

  return false
}

const selectItem = (groupIndex, commandIndex) => {
  const command = newGroups?.value?.[groupIndex].commands[commandIndex]
  executeCommand(command)
}

const executeCommand = (command) => {
  const { view, state } = props.editor
  const { $head, $from } = view.state.selection
  const end = $from.pos
  const from = $head?.nodeBefore
    ? end - ($head.nodeBefore.text?.substring($head.nodeBefore.text?.indexOf('/')).length ?? 0)
    : $from.start()
  const tr = state.tr.deleteRange(from, end)
  view.dispatch(tr)

  command.action(props.editor)
  view.focus()
}
</script>

<style scoped>
/* total width */
::-webkit-scrollbar {
  background-color: #F1EEEE;
  width: 12px;
}

/* background of the scrollbar except button or resizer */
::-webkit-scrollbar-track {
  background-color: #F1EEEE;
}

/* scrollbar itself */
::-webkit-scrollbar-thumb {
  background-color: #babac0;
  border-radius: 16px;
  border: 4px solid #F1EEEE;
}

/* set button(top and bottom of the scrollbar) */
::-webkit-scrollbar-button {
  display:none;
}

.cardShadow {
  box-shadow: 0px 2px 2px 0px rgba(0, 0, 0, 0.14), 0px 3px 1px 0px rgba(0, 0, 0, 0.12), 0px 1px 5px 0px rgba(0, 0, 0, 0.20);
}
</style>